import utime as time
import math
import pyb
import gc
import uos as os
import sensor
import image
from utility import *
from myservo import *

clock = time.clock()
led = pyb.LED(1)

# switch
btn_pause = False  #index=2
btn_pause_soft = False
btn_sleep = 1000

btn_reset = False  #index=1

# servo
servo_x_pid = PID()
servo_y_pid = PID()

servo_x_pid.kp = 1.0
servo_x_pid.ki = 0.0
servo_x_pid.kd = 0.0

servo_y_pid.kp = 1.0
servo_y_pid.ki = 0.0
servo_y_pid.kd = 0.0
servo_x_cur = 56.6137
servo_y_cur = 52.552
servo_x_cur_reset = 56.6137
servo_y_cur_reset = 52.552
servo_move_cycle = 200

# main rect
main_rect = ()
main_rect_margin = 15
img_width = 320
img_height = 240

# big_rect
big_rect = []

# black_rect

black_rect = []
black_rect_padding = -10
black_rect_mid_offset = 4.5

# red point
# L_min L_max A_min A_max B_min B_max
#ray_red = (30, 100, 20, 127, -40, 40)
ray_red = (20, 100, 10, 127, -40, 40)
ray_red_core = (165, 255)

ray_red_dark = [(41, 100, 16, 127, -33, 127), (0, 100, 9, 127, -25, 34)]
ray_red_core_2 = (0, 255)

"""
blob:
0: left_top_x
1: left_top_y
2: width
3: height
4: number of pixel
5: center_x
6: center_y
7: rotation
8: cross number
9: index
"""


kernel_size = 1
sobel_kernel_x = [-1, -2, -1,\
                  +0, +0, +0,\
                  +1, +2, +1]

sobel_kernel_y = [-1, +0, +1,\
                  -2, +0, +2,\
                  -1, +0, +1]

kernel = [-1, -1, -1,\
          -1, +8, -1,\
          -1, -1, -1]

kernel2 = [+1, +2, +1,\
           +2, +0, +2,\
           +1, +2, +1]

sharp_kernel = [-2, -1,  0, \
                -1,  1,  1, \
                 0,  1,  2]

def dda(sets, x0, y0, x1, y1, n):
    dis_x = x1 - x0
    dis_y = y1 - y0
    dx = dis_x / n
    dy = dis_y / n
    for i in range(n + 1):
        x = int(x0 + dx * i + 0.5)
        y = int(y0 + dy * i + 0.5)
        sets.append((x, y))

def led_tip():
    global servo_x_cur
    global servo_y_cur
    led.on()
    time.sleep_ms(800)
    led.off()
#    servo_set(servo_x_cur, servo_y_cur, True)
#    time.sleep_ms(600)
#    servo_set(servo_x_cur, servo_y_cur, False)


def servo_reset(reset=False):
    global btn_pause
    global btn_pause_soft
    global btn_reset
    global servo_x_cur
    global servo_y_cur

    if reset:
        sta = servo_set(servo_x_cur_reset, servo_y_cur_reset, False)
        servo_x_cur = servo_x_cur_reset
        servo_y_cur = servo_y_cur_reset
    else:
        sta = servo_set(servo_x_cur, servo_y_cur, False)
#    print(sta)
    btn_pause = sta[2]
    if btn_reset != sta[1]:
        btn_pause_soft = False
        time.sleep_ms(btn_sleep)
    btn_reset = sta[1]
    time.sleep_ms(50)

#0.35
def servo_move_to(target_x, target_y, now_x, now_y, u_th):
    global servo_x_cur
    global servo_y_cur
    global btn_pause
    global btn_pause_soft
    global btn_reset
    if now_x > -1 and now_y > -1:
        err = math.sqrt(math.pow(target_x - now_x, 2) + math.pow(target_y - now_y, 2))
        u_x = servo_x_pid.pid_iter(target_x, now_x)
        u_y = servo_y_pid.pid_iter(target_y, now_y)
        if get_abs(u_x) > u_th:
            u_x = u_th if u_x > 0 else -u_th
        if get_abs(u_y) > u_th:
            u_y = u_th if u_y > 0 else -u_th
        servo_x_cur = servo_x_cur - u_x
        servo_y_cur = servo_y_cur - u_y
        sta = servo_set(servo_x_cur, servo_y_cur, False)
#        print(sta)
        btn_pause = sta[2]
        if btn_reset != sta[1]:
            btn_pause_soft = False
        btn_reset = sta[1]
#        print(-u_x, -u_y, target_x - now_x, target_y - now_y, err, servo_x_cur, servo_y_cur)
        return err
    return 9999

def get_relpos(x, y):
    return ((x - main_rect[0]) / main_rect[2], (y - main_rect[1]) / main_rect[3])

def get_oripos(x, y):
    return (int(main_rect[0] + x * main_rect[2]), int(main_rect[1] + y * main_rect[3]))

def task_1(loop=True):
    global program_state
    global main_rect
    global main_rect_margin
    global btn_pause_soft
    global btn_pause

    servo_move_count = 0
    program_state = 0
    btn_pause_soft = True
    sensor.reset()
    sensor.set_pixformat(sensor.RGB565)
    sensor.set_framesize(sensor.QVGA) #QQVGA: 160x120 #CIF
#    sensor.set_contrast(2)
#    sensor.set_brightness(-2)
#    sensor.set_saturation(3)
    sensor.set_auto_gain(False)
    sensor.set_auto_whitebal(False)
    sensor.skip_frames(time=1000)
    point_set = []
    point_cur_index = 0
    width_thres = 60
    err_thres = 0.01

    servo_x_pid.kp = 3.0
    servo_x_pid.ki = 0.0
    servo_x_pid.kd = 0.0
    servo_x_pid.pid_cla()

    servo_y_pid.kp = 3.0
    servo_y_pid.ki = 0.0
    servo_y_pid.kd = 0.0
    servo_y_pid.pid_cla()
    while True:
        clock.tick()
        img = sensor.snapshot().lens_corr(strength=1.05, zoom=1.0)
        if program_state == 0:
            # set roi
            alen = img_height - 2*main_rect_margin
            left = (img_width - alen) // 2
            main_rect = (left, main_rect_margin, alen, alen)
            img.draw_rectangle(left, main_rect_margin, alen, alen, color=(128, 64, 250))
            if btn_pause_soft:
                servo_reset(True)
                continue
            elif btn_pause:
                servo_reset(False)
                continue
            # find big rect
            led.on()
            for r in img.find_rects(threshold=4000, roi=main_rect):
                for c in r.corners():
                    img.draw_cross(c, color=255)
                if abs(r.w() - r.h()) < 15 and abs(r.w() - alen) < width_thres:
                    c = r.corners()
                    # sort corners
                    cm = (r.x() + r.w() // 2, r.y() + r.h() // 2)
                    c_left = []
                    c_right = []
                    for i in c:
                        if i[0] < cm[0]:
                            c_left.append(i)
                        else:
                            c_right.append(i)
                    if c_left[0][1] < c_left[1][1]:
                        c0 = c_left[0]
                        c3 = c_left[1]
                    else:
                        c0 = c_left[1]
                        c3 = c_left[0]
                    if c_right[0][1] < c_right[1][1]: #todo
                        c1 = c_right[0]
                        c2 = c_right[1]
                    else:
                        c1 = c_right[1]
                        c2 = c_right[0]
                    img.draw_cross(c0[0], c0[1])
                    img.draw_cross(c1[0], c1[1])
                    img.draw_cross(c2[0], c2[1])
                    img.draw_cross(c3[0], c3[1])
                    dis_02 = math.sqrt(math.pow(c2[0] - c0[0], 2) + math.pow(c2[1] - c0[1], 2))
                    dis_13 = math.sqrt(math.pow(c1[0] - c3[0], 2) + math.pow(c3[1] - c1[1], 2))
#                    cm = (c0[0] + (dis_02 + dis_13) // 5.65685,
#                          c0[1] + (dis_02 + dis_13) // 5.65685)
                    if dis_02 > dis_13:
                        ratio = dis_02 / dis_13
                    else:
                        ratio = dis_13 / dis_02
                    # judege
                    if ratio > 0.9 and ratio < 1.1:
                        big_rect = (cm, c0, c1, c2, c3)
                        point_set = []
                        dda(point_set, big_rect[1][0], big_rect[1][1],
                                       big_rect[2][0], big_rect[2][1], 5)
                        dda(point_set, big_rect[2][0], big_rect[2][1],
                                       big_rect[3][0], big_rect[3][1], 5)
                        dda(point_set, big_rect[3][0], big_rect[3][1],
                                       big_rect[4][0], big_rect[4][1], 5)
                        dda(point_set, big_rect[4][0], big_rect[4][1],
                                       big_rect[1][0], big_rect[1][1], 5)
                        program_state = 1
                        btn_pause_soft = True
                        led.off()
                        # led_tip()

        else:
            if btn_pause_soft:
                servo_reset(True)
                continue
            elif btn_pause:
                servo_reset(False)
                continue
            # find red point
            blobs = img.find_blobs([ray_red], roi=main_rect)
            red_x = -2
            red_y = -2

            red_x_sum = 0
            red_y_sum = 0
            red_x_core_sum = 0
            red_y_core_sum = 0

            red_count = 0
            red_core_count = 0

            for b in blobs:
                red_x_sum = red_x_sum + get_relpos(b[5], b[6])[0]
                red_y_sum = red_y_sum + get_relpos(b[5], b[6])[1]
                red_count = red_count + 1
                red_rect = img.to_grayscale(roi=b[0:4], copy=True)
                red_rect_blobs = red_rect.find_blobs([ray_red_core])
                for bb in red_rect_blobs:
                    red_x_core_sum = red_x_core_sum + get_relpos(b[5], b[6])[0]
                    red_y_core_sum = red_y_core_sum + get_relpos(b[5], b[6])[1]
                    red_core_count = red_core_count + 1
            if red_core_count > 0:
                red_x = red_x_core_sum / red_core_count
                red_y = red_y_core_sum / red_core_count
            elif red_count > 0:
                red_x = red_x_sum / red_count
                red_y = red_y_sum / red_count

            img.draw_rectangle(main_rect, color=(0, 128, 255))
            img.draw_cross(get_oripos(red_x, red_y))

            # move to center
            if program_state == 1:
                t = get_relpos(*big_rect[0])
                err = servo_move_to(t[0], t[1], red_x, red_y, 0.35)
                if err <= err_thres:
                    program_state = 2
                    time.sleep_ms(1500)

            # move to 0
            elif program_state == 2:
                t = point_set[point_cur_index]
                t = get_relpos(*t)
                err = servo_move_to(t[0], t[1], red_x, red_y, 0.24)
                if err <= err_thres:
                    point_cur_index = point_cur_index + 1
                    if point_cur_index == len(point_set):
                        point_cur_index = 0
                        if loop == False:
                            time.sleep_ms(1500)
                            break



def task_2(loop=True):
    global main_rect
    global main_rect_margin
    global black_rect
    global servo_x_pid
    global servo_y_pid
    global servo_move_cycle
    global btn_pause_soft
    global btn_pause

    # init
    btn_pause_soft = True
    sensor.reset()
    sensor.set_pixformat(sensor.RGB565)
    sensor.set_framesize(sensor.QVGA) #QQVGA: 160x120 #CIF
    #sensor.set_contrast(-3)
    #sensor.set_brightness(-2)
    #sensor.set_saturation(3)
    sensor.set_auto_gain(True)
    sensor.set_auto_whitebal(False)
    sensor.skip_frames(time=1000)
    # variance
    servo_move_count = 0
    program_state = 0
    point_set = []
    point_cur_index = 0
    dda_n = 8
    # pid
    err_thres = 0.010
    servo_x_pid.kp = 5.0
    servo_x_pid.ki = 0.0
    servo_x_pid.kd = 0.0
    servo_x_pid.pid_cla()

    servo_y_pid.kp = 5.0
    servo_y_pid.ki = 0.0
    servo_y_pid.kd = 0.0
    servo_y_pid.pid_cla()
    while True:
        clock.tick()
        img = sensor.snapshot().lens_corr(strength=1.05, zoom=1.0)
        if program_state == 0:
            if btn_pause_soft:
                servo_reset(True)
                continue
            elif btn_pause:
                servo_reset(False)
                continue
            # set roi
            led.on()
            alen = img_height - 2*main_rect_margin
            left = (img_width - alen) // 2
            main_rect = (left, main_rect_margin, alen, alen)
            img.draw_rectangle(left, main_rect_margin, alen, alen, color=(128, 64, 250))
            # find black rect
            for b in img.find_blobs([(0, 15, -127, 127, -127, 127)], roi=main_rect):
                b_x = b[0] + black_rect_padding
                b_y = b[1] + black_rect_padding
                b_w = b[2] - 2*black_rect_padding
                b_h = b[3] - 2*black_rect_padding
                if b_x > 0 and b_y > 0 and b_w > 50 and b_h > 50:
                    black_roi = (b_x, b_y, b_w, b_h)
                    img.draw_rectangle(black_roi, color=255)
                    program_state = 1
        elif program_state == 1:
            img.to_grayscale()
            img.binary([(0, 30)])
#            continue
            for r in img.find_rects(threshold=300, roi=main_rect):
                c = r.corners()
                # sort corners
                cm = (r.x() + r.w() // 2, r.y() + r.h() // 2)
                c_left = []
                c_right = []
                for i in c:
                    if i[0] < cm[0]:
                        c_left.append(i)
                    else:
                        c_right.append(i)
                if len(c_left) != 2 or len(c_right) != 2:
                    continue
                if c_left[0][1] < c_left[1][1]:
                    c0 = c_left[0]
                    c3 = c_left[1]
                else:
                    c0 = c_left[1]
                    c3 = c_left[0]
                if c_right[0][1] < c_right[1][1]:
                    c1 = c_right[0]
                    c2 = c_right[1]
                else:
                    c1 = c_right[1]
                    c2 = c_right[0]
                cs = [c0, c1, c2, c3]
                # judge
                dis_02 = math.sqrt(math.pow(c2[0] - c0[0], 2) + math.pow(c2[1] - c0[1], 2))
                dis_13 = math.sqrt(math.pow(c1[0] - c3[0], 2) + math.pow(c3[1] - c1[1], 2))
                if dis_02 <= 0 and dis_13 <= 0:
                    continue
                if dis_02 > dis_13:
                    ratio = dis_02 / dis_13
                else:
                    ratio = dis_13 / dis_02
                if ratio > 0.9 and ratio < 1.1:
                    # count diagonal white pixel
                    white_count = 0
                    x0 = c0[0]
                    y0 = c0[1]
                    x1 = c2[0]
                    y1 = c2[1]
                    dis_x = x1 - x0
                    dis_y = y1 - y0
                    n = max(abs(dis_x), abs(dis_y))
                    dx = dis_x / n
                    dy = dis_y / n
                    for i in range(n + 1):
                        x = int(x0 + dx * i + 0.5)
                        y = int(y0 + dy * i + 0.5)
                        if img.get_pixel(x, y) > 150:
                            white_count = white_count + 1
                    # judge inner or outter
                    if white_count > 9:
                        # ouuter
                        mid_offset = black_rect_mid_offset
                        print('find_outter')
                    else:
                        # inner
                        mid_offset = -black_rect_mid_offset
                        print('find_inner')
                    # make bias
                    black_rect = []
                    black_rect.append(cm)
                    for ci in cs:
                        dx = cm[0] - ci[0]
                        dy = cm[1] - ci[1]
                        dxy = math.sqrt(math.pow(dx,2) + math.pow(dy,2))
                        dr_x = abs(dx) / dxy
                        dr_y = abs(dy) / dxy
                        if dx > 0:
                            delta_x = dr_x * mid_offset
                        else:
                            delta_x = -dr_x * mid_offset
                        if dy > 0:
                            delta_y = dr_y * mid_offset
                        else:
                            delta_y = -dr_y * mid_offset
                        ci = (int(ci[0] + delta_x), int(ci[1] + delta_y))
                        black_rect.append((ci[0], ci[1]))
                        img.draw_cross(ci[0], ci[1], color=20)
                    # make point set
                    point_set = []
                    dda(point_set, black_rect[1][0], black_rect[1][1],
                                   black_rect[2][0], black_rect[2][1], dda_n)
                    dda(point_set, black_rect[2][0], black_rect[2][1],
                                   black_rect[3][0], black_rect[3][1], dda_n)
                    dda(point_set, black_rect[3][0], black_rect[3][1],
                                   black_rect[4][0], black_rect[4][1], dda_n)
                    dda(point_set, black_rect[4][0], black_rect[4][1],
                                   black_rect[1][0], black_rect[1][1], dda_n)
#                    print(point_set)
                    program_state = 2
                    btn_pause_soft = True
                    led.off()
                    # led_tip()
            img.draw_rectangle(black_roi, color=255)
        else:
            if btn_pause_soft:
                servo_reset(True)
                continue
            elif btn_pause:
                servo_reset(False)
                continue
            # find red point
            mask = sensor.alloc_extra_fb(320, 240, sensor.RGB565)
            mask.replace(img)
            mask.binary([(30, 100, 13, 127, -25, 25)])
            mask.dilate(1)
            img.set((193, 78, 121), mask=mask)
            sensor.dealloc_extra_fb()
#            continue
            blobs = img.find_blobs(ray_red_dark, roi=black_roi,
                                    x_stride=1, y_stride=1,
                                    area_threshold=1, pixel_threshold=1,
                                    merge=True)
            red_x = -2
            red_y = -2

            red_x_sum = 0
            red_y_sum = 0
            red_x_core_sum = 0
            red_y_core_sum = 0

            red_count = 0
            red_core_count = 0

            for b in blobs:
                red_x_sum = red_x_sum + get_relpos(b[5], b[6])[0]
                red_y_sum = red_y_sum + get_relpos(b[5], b[6])[1]
                red_count = red_count + 1
            if red_count > 0:
                red_x = red_x_sum / red_count
                red_y = red_y_sum / red_count

            img.draw_rectangle(main_rect, color=(0, 0, 255))
            img.draw_rectangle(black_roi, color=(0, 120, 255))
            img.draw_cross(get_oripos(red_x, red_y))

            t = point_set[point_cur_index]
            t = get_relpos(*t)
            err = servo_move_to(t[0], t[1], red_x, red_y, 0.24)
            if err <= err_thres:
                point_cur_index = point_cur_index + 1
                if point_cur_index == len(point_set):
                    point_cur_index = 0
                    if loop == False:
                        break


task_1(loop=False)
task_2(loop=False)
task_2(loop=True)
