from pyb import UART
import ustruct as struct
import utime as time

baudrate = 115200
uart = UART(3)  #(TX, RX) = (P4, P5) = (PB10, PB11)
uart.init(baudrate, bits=8, parity=None, stop=1, timeout_char=10, timeout=10)

def servo_sync():
    print('servo_sync')
    for i in range(16):
        uart.writechar(0)
        if uart.readchar() != -1:
            print('servo_sync_successfully')
            break

def servo_set(servo0, servo1, beep):
    buf = struct.pack('>ffB', servo0, servo1, (64 if beep else 1))
    uart.write(buf)
    state = uart.readchar()
    if state == -1:
        servo_sync()
        return servo_set(servo0, servo1, beep)
    else:
        return True if state&0x04 else False, False if state&0x02 else True, False if state&0x01 else True

#for i in range(1000):
#    target = i/10
#    print(servo_set(target, 30, False))
#    time.sleep(0.1)
