#ifndef __ULibTask_H__
#define __ULibTask_H__

#define ULibTaskReturnCode_Done 0
#define ULibTaskReturnCode_Noop 1
#define ULibTaskReturnCode_Full 2
#define ULibTaskReturnCode_Empty 3
#define ULibTaskReturnCode_Error 4
#define ULibTaskReturnCode_NotFound 5
typedef unsigned char ULibTaskReturnCode;

#define ULibTaskState_Idle 0
#define ULibTaskState_Active 16
typedef unsigned char ULibTaskState;
typedef unsigned char ULibTaskPriority;
typedef unsigned char ULibTaskBreakPoint;
typedef void (*ULibTaskFunction)(struct _ULibTask *);
typedef struct _ULibTask
{
    ULibTaskState s;
    ULibTaskPriority p;
    ULibTaskFunction f;
    ULibTaskBreakPoint bp;
} ULibTask, *ULibTaskAddr;

#define ULibTaskList_MaxCount 16
typedef unsigned char ULibTaskListCount;
typedef struct _ULibTaskList
{
    ULibTaskListCount c;
    ULibTaskAddr tp[ULibTaskList_MaxCount];
} ULibTaskList;

typedef unsigned short ULibTMRCycle;
typedef struct _ULibTMRTask
{
    ULibTMRCycle c;
    ULibTMRCycle _c;
    ULibTaskAddr tp;
    ULibTaskBreakPoint bp;
} ULibTMRTask, *ULibTMRTaskAddr;

#define ULibTMRTaskList_MaxCount 5
typedef unsigned char ULibTMRTaskListCount;
typedef struct _ULibTMRTaskList
{
    ULibTMRCycle _c;
    unsigned char temp[3];
    ULibTMRTaskListCount c;
    ULibTMRTaskAddr tp[ULibTMRTaskList_MaxCount];
} ULibTMRTaskList;

ULibTaskReturnCode ULibTaskPut(ULibTaskList *taskList, ULibTaskAddr taskAddr);
ULibTaskReturnCode ULibTaskPop(ULibTaskList *taskList, ULibTaskAddr taskAddr);
ULibTaskReturnCode ULibTaskNext(ULibTaskList *taskList);

ULibTaskReturnCode ULibTMRTaskPut(ULibTMRTaskList *TMRTaskList, ULibTMRTaskAddr TMRTaskAddr);
ULibTaskReturnCode ULibTMRTaskPop(ULibTMRTaskList *TMRTaskList, ULibTMRTaskAddr TMRTaskAddr);
ULibTaskReturnCode ULibTMRTaskPlus(ULibTMRTaskList *TMRTaskList, ULibTMRCycle TMRCycle);
ULibTaskReturnCode ULibTMRTaskCheck(ULibTMRTaskList *TMRTaskList);

#endif